﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
//Add code

using System.IO;
using System.IO.Ports;
namespace Basic_Terminal
{
    
    public partial class Main_Form : Form
    {
        Serial serial = new Serial(); // Uart Open
        Bluecell_BootProtocol bluecell_BootProtocol = new Bluecell_BootProtocol();
        Update_Serial file = new Update_Serial();
        public Main_Form()
        {
            InitializeComponent();
            serial.Serial_Initialize(ref comboBox_Port);
        }
       
        private void Firmware_Update_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            //FileDownload file = new FileDownload();
            if (Ascii_checkBox.Checked == true)
                Ascii_checkBox.Checked = false;
            file.ShowFileOpenDialog(ref serial, ofd);
        }
        private void Crc16_Check_Click(object sender, EventArgs e)
        {
#if false
            Crc16 crc16 = new Crc16();
            byte[] tempdata = { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09,0x0A };
            label1.Text = crc16.CRC16_Generate(tempdata, 11).ToString();
#endif
            this.serial.Test_Serial();
        }

        private void Button_PortOpen_Click(object sender, EventArgs e)
        {
            bool ret = false;
            ret = Serial_connectiondisable(serial.Serial_PortOpen(ref button_PortOpen, ref comboBox_Port));
            if (ret == false && timer.Enabled == false)
            {
                timer.Start(); //타이머를 발동시킨다.
            }
            else if (timer.Enabled == true)
            {
                timer.Stop(); //타이머를 멈춘다.
            }
            else
            {
                /*NOP*/
            }
            serial.Serial_Main_Form_Get(this);
        }

        private void ComboBox_Port_SelectedIndexChanged(object sender, EventArgs e)
        {
            
            //serial.Serial_Name = comboBox_Port.SelectedItem.ToString();
        }

        private void Button_terminal_Click(object sender, EventArgs e)
        {
            serial.Serial_TerminalOpen(serial);
        }
        public bool Serial_connectiondisable(Boolean on_off)
        {
            comboBox_Port.Enabled = on_off;
            comboBox_baudrate.Enabled = on_off;

            return on_off;
        }
        private delegate void BoolSet();

        public void TX_Light_ON()
        {
            this.pictureBox_G_TX.Visible = true;
            this.pictureBox_R_TX.Visible = false;
        }
        public void TX_Light_OFF()
        {
            this.pictureBox_R_TX.Visible = true;
            this.pictureBox_G_TX.Visible = false;
        }
        public void RX_Light_ON()
        {
            this.pictureBox_G_RX.Visible = true;
            this.pictureBox_R_RX.Visible = false;
        }
        public void RX_Light_OFF()
        {
            this.pictureBox_R_RX.Visible = true;
            this.pictureBox_G_RX.Visible = false;
        }
        Int64 Timer_Cnt = 0;
        Int32 ReqTimer_Cnt = 0;
        public bool TX_RX_Light = false;
        private void timer_Tick(object sender, EventArgs e)
        {
            Update_Serial update_Serial = null;
            bool req_set = false;
            if(update_Serial == null)
            {
                update_Serial = (Update_Serial)serial.FileDownloadClass_Get();
                if (update_Serial == null)
                    req_set = true;
                else if(update_Serial.Update_ready == false)
                    req_set = true;
            }
            if (req_set)
            {
                ReqTimer_Cnt++;
            }
            if (TX_RX_Light == true)
            {
                Timer_Cnt++;
            }
            if (Timer_Cnt < 1000)
            {
                if (this.pictureBox_G_TX.Visible == true)
                {
                    TX_Light_OFF();
                }
                if (this.pictureBox_G_RX.Visible == true)
                {
                    RX_Light_OFF();
                }
                Timer_Cnt = 0;
                TX_RX_Light = false;
            }
          if(ReqTimer_Cnt > 6)
            {
               // bluecell_BootProtocol.Bluecell_RF_Status_Req(serial);
                ReqTimer_Cnt = 0;
            }
        }
        private void comboBox_Port_MouseDown(object sender, MouseEventArgs e)
        {
            serial.SetPortNameValues(comboBox_Port);
        }

    }
}
